package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.JenisKartuDetail;
import com.jasamedika.medifirst2000.vo.JenisKartuDetailVO;

/**
 * Converter class between Pasien and PasienVO
 * 
 * @author Askur
 */
@Component
public class JenisKartuDetailConverter implements BaseVoConverter<JenisKartuDetailVO, JenisKartuDetail> {


	@Override
	public JenisKartuDetail transferVOToModel(JenisKartuDetailVO vo, JenisKartuDetail model) {
		if (null == model)
			model = new JenisKartuDetail();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, JenisKartuDetail.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return model;
	}

	@Override
	public List<JenisKartuDetailVO> transferListOfModelToListOfVO(List<JenisKartuDetail> models, List<JenisKartuDetailVO> vos) {

		if (null == vos)
			vos = new ArrayList<JenisKartuDetailVO>();

		if (null == models)
			return vos;

		for (JenisKartuDetail pegawai : models) {
			JenisKartuDetailVO vo = new JenisKartuDetailVO();
			vo=transferModelToVO(pegawai, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public JenisKartuDetailVO transferModelToVO(JenisKartuDetail model, JenisKartuDetailVO vo) {
		if (null == vo)
			vo = new JenisKartuDetailVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, JenisKartuDetailVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	
	
	

}
